/***********************************************************************

	File:	genps.h
	Rev:	a-1
	Date:	11/05/98

	Copyright (c) 1993, 1999 by David M. Warme

************************************************************************

	Stuff for generating plots in postscript.

************************************************************************

	Modification Log:

	a-1:	11/05/98	warme
		: Created.  Split off from steiner.h.

************************************************************************/

#ifndef	GENPS_H
#define	GENPS_H

#include "steiner.h"


/*
 * Enumerated type to identify a plot size.  Big is a single plot per
 * page.  Small is 12 plots per page.
 */

enum plot_size {
	BIG_PLOT,
	SMALL_PLOT
};


/*
 * Function Prototypes.
 */

extern void		begin_plot (enum plot_size);
extern void		define_Plot_Terminals (struct pset *, double);
extern void		draw_segment (struct point *, struct point *);
extern void		end_plot (char *);
extern void		overlay_plot_subset (char *,
					     bitmap_t *,
					     struct cinfo *,
					     enum plot_size);
extern void		plot_full_sets (bitmap_t *,
					struct cinfo *,
					enum plot_size);
extern void		plot_full_sets_grouped (bitmap_t *,
						struct cinfo *,
						enum plot_size);
extern void		plot_lp_solution (char *,
					  double *,
					  struct cinfo *,
					  enum plot_size);

#endif
