/***********************************************************************

	File:	sec_heur.h
	Rev:	a-1
	Date:	05/13/96

	Copyright (c) 1996, 1999 by David M. Warme

************************************************************************

	Data structures for the various heuristic separation
	procedures for Strong SEC's (Subtour Elimination
	Constraints).

************************************************************************

	Modification Log:

	a-1:	05/13/96	warme
		: Created.

************************************************************************/

#ifndef SEC_HEUR_H
#define	SEC_HEUR_H

#include "bb.h"
#include "constrnt.h"
#include "sec_comp.h"
#include "steiner.h"
/*
 * Size of largest subproblem that we separate via exhaustive enumeration.
 */

#define	SEC_ENUM_LIMIT		10


/*
 * Function Prototypes
 */

	/* Pre-declarations of structure tags... */
	struct bbnode;
	struct constraint;

extern struct constraint *	check_subtour (bitmap_t *,
					       struct constraint *,
					       double *,
					       bitmap_t *,
					       struct cinfo *);
extern struct constraint *	enumerate_all_subtours (struct comp *,
							struct constraint *,
							struct bbnode *);
extern struct constraint *	find_integer_cycles (double *,
						     bitmap_t *,
						     bitmap_t *,
						     struct constraint *,
						     struct cinfo *);
extern struct constraint *	find_small_subtours (struct comp *,
						     struct constraint *,
						     struct bbnode *);
extern bool			is_equal (bitmap_t *, bitmap_t *, int);
extern struct constraint *	sec_flow_heuristic (struct comp *,
						    double *,
						    bitmap_t *,
						    struct cinfo *,
						    struct constraint *);


#endif
